<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema">
<xsl:template match="/Process">
<table width="100%" cellpadding="1" cellspacing="2" border="0"> 
 <tr class="main_page_table_header"> 
   <!--Get timestamp from system properties-->
   <td colspan="3">Actual status at <xsl:value-of select="document('/System/Properties/TIMES/TIME')/TIME/@_"/></td> 
   <td align="right" width="100px"><button type="button" class="ButtonShort" onclick="xmlload();">Refresh</button></td>
 </tr> 
</table>
   <!--Select Bus tags-->
   <xsl:for-each select="*">
   <!--remember current bus name/position for later addressing-->
   <xsl:variable name="busposition" select="position()"/>
   <xsl:variable name="busname" select="name()"/>
    <!--selevt only busses-->
    <xsl:if test="starts-with(name(),'Bus')">
	<table width="100%" cellpadding="1" cellspacing="2" border="0"> 
   	<!--Select all devices-->
	<xsl:for-each select="*">
	  <!--remember current device position for later addressing-->
	  <xsl:variable name="deviceposition" select="position()"/>
	   	<!--Don't select the last two which are 'Active' and 'FreeMem'-->
		<xsl:if test="position() &lt; last() -1">
				<tr class="main_page_table_separator"> 
			   	<!--Get device name from external-->
			             <td colspan="4">
					<xsl:value-of select="document('/System/Config/PROCCFG/External/')/External/Bus[$busposition]/Device[$deviceposition]/@NameUser"/> - Communication: 
					<!--check communication-->
					<xsl:choose>
						<xsl:when test="DeviceState/@_ = 1">OK</xsl:when>
						<xsl:otherwise><font color="#FF0000">Failure</font></xsl:otherwise>
					</xsl:choose>
				     </td>
			        </tr> 
		</xsl:if>
		<!--Show variables only if DeviceState=1-->
		<xsl:if test="DeviceState/@_ = 1">
	   	<!--Select all variables-->
		<xsl:for-each select="*"> 
		  <!--remember current variable position for later addressing-->
		  <xsl:variable name="variableposition" select="position()"/>
			<!--Don't select the fist two which are 'DeviceState' and 'ChangeToggle'-->
 			<xsl:if test="position() &gt; 2">
				<tr class="main_page_table_data">
					<td width="46%">
					<xsl:choose>
						<xsl:when test="@Name"> 
							<xsl:value-of select="@Name" />
						</xsl:when>
						<xsl:otherwise> 
							<xsl:value-of select="name(.)" />
						</xsl:otherwise>
					</xsl:choose>
					</td>
					<!--add option for write access-->
					<xsl:choose>
 					<xsl:when test="document('/System/Config/PROCCFG/External/')/External/Bus[$busposition]/Device[$deviceposition]/*[$variableposition -2]/@acc = 'RW' or document('/System/Config/PROCCFG/External/')/External/Bus[$busposition]/Device[$deviceposition]/*[$variableposition -2]/@acc = 'RWA' or document('/System/Config/PROCCFG/External/')/External/Bus[$busposition]/Device[$deviceposition]/*[$variableposition -2]/@acc = 'RWL'">
	 					<xsl:if test="document('/System/Config/PROCCFG/External/')/External/Bus[$busposition]/Device[$deviceposition]/*[$variableposition -2]/@simpleType != 'Bit'">
							<FORM action="../cgi-bin/writeVal.exe" method="get" target="NullDevice">
							   <td width="12%" align="center">
							    <INPUT type="text" size="10" value=""><xsl:attribute name="name">/Process/<xsl:value-of select="$busname"/>/<xsl:value-of select="name(..)"/>/<xsl:value-of select="name()"/></xsl:attribute></INPUT></td>
							   <td width="12%" align="center">
							    <INPUT type="submit" class="ButtonShort" value="Set"/>
							   </td>
							</FORM>
							<td>
								<xsl:value-of select="@_" />
							</td>
						</xsl:if>
	 					<xsl:if test="document('/System/Config/PROCCFG/External/')/External/Bus[$busposition]/Device[$deviceposition]/*[$variableposition -2]/@simpleType = 'Bit'">
 		      					<td width="12%" align="center"><button type="button" class="ButtonShort"><xsl:attribute name="onclick">writeVal(1,'/Process/<xsl:value-of select="$busname"/>/<xsl:value-of select="name(..)"/>/<xsl:value-of select="name()"/>');</xsl:attribute>Setzen</button></td>
 		      					<td width="12%" align="center"><button type="button" class="ButtonShort"><xsl:attribute name="onclick">writeVal(0,'/Process/<xsl:value-of select="$busname"/>/<xsl:value-of select="name(..)"/>/<xsl:value-of select="name()"/>');</xsl:attribute>Reset</button></td>
							<td>
								<xsl:value-of select="@_" />
							</td>
						</xsl:if>
					</xsl:when>
					<xsl:otherwise> 
						<td width="24%" align="center" colspan="2"></td>
						<td>
							<xsl:value-of select="@_" />
						</td>
					</xsl:otherwise>
					</xsl:choose>
				</tr>
			</xsl:if>
		</xsl:for-each> 
		</xsl:if>
	</xsl:for-each>
	</table> 
     </xsl:if>

   </xsl:for-each>


   <!--Select Mainboard IOs-->
   <xsl:for-each select="MB/IO/I">
	<table width="100%" cellpadding="1" cellspacing="2" border="0"> 
				<tr class="main_page_table_separator"> 
			         <td colspan="4">Mainboard Inputs:</td> 
			        </tr> 
   	<!--Select all Ports-->
	<xsl:for-each select="*">
				<tr class="main_page_table_data">
					<td width="46%">
						Input <xsl:value-of select="position()"/>
					</td>
					<td width="24%" align="center"></td>
					<td colspan="2">
						<xsl:value-of select="@_" />
					</td>
				</tr>
	</xsl:for-each>
	</table> 
   </xsl:for-each>
   <xsl:for-each select="MB/IO/Q">
	<table width="100%" cellpadding="1" cellspacing="2" border="0"> 
				<tr class="main_page_table_separator"> 
			         <td colspan="4">Mainboard Outputs:</td> 
			        </tr> 
   	<!--Select all Ports-->
	<xsl:for-each select="*">
				<tr class="main_page_table_data">
					<td width="46%">
						Output <xsl:value-of select="position()"/>
					</td>
 		      			<td width="12%" align="center"><button type="button" class="ButtonShort"><xsl:attribute name="onclick">writeVal(1,'/Process/MB/IO/Q/P<xsl:value-of select="position() -1"/>');</xsl:attribute>Set</button></td>
 		      			<td width="12%" align="center"><button type="button" class="ButtonShort"><xsl:attribute name="onclick">writeVal(0,'/Process/MB/IO/Q/P<xsl:value-of select="position() -1"/>');</xsl:attribute>Reset</button></td>
					<td>
						<xsl:value-of select="@_" />
					</td>
				</tr>
	</xsl:for-each>
	</table> 
   </xsl:for-each>
   <xsl:for-each select="MB/A/AI">
	<table width="100%" cellpadding="1" cellspacing="2" border="0"> 
				<tr class="main_page_table_separator"> 
			         <td colspan="4">Mainboard Analog Input:</td> 
			        </tr> 
   	<!--Select all Ports-->
	<xsl:for-each select="*">
				<tr class="main_page_table_data">
					<td width="46%">
						Analog Input
					</td>
					<td width="24%" align="center"></td>
					<td colspan="2">
						<xsl:value-of select="@_" />
					</td>
				</tr>
	</xsl:for-each>
	</table> 
   </xsl:for-each>

   <!--Select extension IOs-->
   <xsl:for-each select="*/I">
	<table width="100%" cellpadding="1" cellspacing="2" border="0"> 
				<tr class="main_page_table_separator"> 
			         <td colspan="4"><xsl:value-of select="name(..)"/> Inputs:</td> 
			        </tr> 
   	<!--Select all Ports-->
	<xsl:for-each select="*">
				<tr class="main_page_table_data">
					<td width="46%">
						Input <xsl:value-of select="position()"/>
					</td>
					<td width="24%" align="center"></td>
					<td colspan="2">
						<xsl:value-of select="@_" />
					</td>
				</tr>
	</xsl:for-each>
	</table> 
   </xsl:for-each>
   <xsl:for-each select="*/Q">
	<table width="100%" cellpadding="1" cellspacing="2" border="0"> 
				<tr class="main_page_table_separator"> 
			         <td colspan="4"><xsl:value-of select="name(..)"/> Outputs:</td> 
			        </tr> 
   	<!--Select all Ports-->
	<xsl:for-each select="*">
				<tr class="main_page_table_data">
					<td width="46%">
						Output <xsl:value-of select="position()"/>
					</td>
 		      			<td width="12%" align="center"><button type="button" class="ButtonShort"><xsl:attribute name="onclick">writeVal(1,'/Process/<xsl:value-of select="name(../../.)"/>/Q/P<xsl:value-of select="position() -1"/>');</xsl:attribute>Set</button></td>
 		      			<td width="12%" align="center"><button type="button" class="ButtonShort"><xsl:attribute name="onclick">writeVal(0,'/Process/<xsl:value-of select="name(../../.)"/>/Q/P<xsl:value-of select="position() -1"/>');</xsl:attribute>Reset</button></td>
					<td>
						<xsl:value-of select="@_" />
					</td>
				</tr>
	</xsl:for-each>
	</table> 
   </xsl:for-each>
</xsl:template>
</xsl:stylesheet> 